  subroutine mc_command(comline,iseed,info)
      use glbconst, only: b_noask,infotext,enwr,nwr,nrd,ncl
      use comscd, only: npanum,queryar,helpar,ext
      use comdat, only: b_datset    
      use comths, only: nfit,ntest
      use comeff, only: pathwidth
      use comfrm, only: kp,mp
      implicit none
     character(len=132), intent(inout):: comline
     integer, intent(out) :: info
     integer, intent(inout):: iseed
     character(len=132):: ch132,chin,querytype,chcom
     character(len=80):: chdf
     character(len=7) :: form      
     character(len=4) :: chft  

     real, dimension(32):: out
     real  pathw,value

     integer i,ih,ipos,ienter,iprobe,j,k,ks,lq,lp,lk,mf,nn

      if(b_noask) then 
       i=index(comline,'s') 
       ch132=comline(3:i-1) 
       call trlch(i,ch132,nn,out) 
       lq=out(1) 
       if(lq.gt.3) goto 1
       iprobe=out(2) 
       if(iprobe.lt.1) goto 1 
       ch132=comline(i-1:) 
       comline='mc '//ch132 
      end if 
      call ks_select(comline,info) 
      if(comline(1:1).eq.'*'.or.comline(1:1).eq.'q') goto 1 
      call nextchar(comline,2,ipos,ch132,ih) 
      lq=0 
      if(ch132(1:2).eq.'gr') then 
       chft='grad' 
      else if(ch132(1:2).eq.'ne') then 
       chft='newt' 
      else if(ch132(1:2).eq.'mq') then 
       chft='marq' 
      else if(ch132(1:2).eq.'pw') then 
       chft='powe' 
      else if(ch132(1:2).eq.'df') then 
       chft='dfpm'     !  implementation under work 
      else 
        chft='marq' 
       write(nwr,'(a)') ' no fitroutine defined -> {mq}' 
      end if 
                                                                        
      nfit(0)=npanum(2) 
      ntest(0)=npanum(2) 
      j=0 
      do k=1,nfit(0) 
       ks=npanum(k+2) 
        j=j+1 
        nfit(j)=ks 
       if(.not.b_datset(ks)) j=j-1 
      end do 
      if(j.eq.0) then 
       info=1 
       infotext(1)='effi/mc/datastorage' 
       infotext(2)='no storage region defined (no data!)' 
       infotext(3)=' ' 
       goto 1 
      end if 
                                                                        
      nfit(0)=j 
      if(lq.eq.0)then 
       chin='fc b1l' 
       ienter=1 
       call ft_condition(chin,ienter,chft,info) 
       pathw=pathwidth 
      else 
       if(nfit(0).gt.1)then 
        nfit(0)=1 
        write(nwr,'(a)')' only one set- the first is taken' 
       end if 
      end if 
                                                                        
      write(nwr,'(a)')                                                  &
      '** old data will be destroyed and replaced by simulated data **'
      if(.not.b_noask) then 
       if(lq.eq.0)then 
        lq=4 
        lk=lq 
        do k=1,lq 
         ext(k)=' ' 
        end do 
        chdf='e' 
        chdf(80:80)='#' 
        chin='data points set to theory +- error (from Monte Carlo)' 
        helpar(1)='effi/synthetic/errors' 
        helpar(2)='effi/synthetic/mc_errors' 
        helpar(3)='effi/synthetic/complete' 
        helpar(4)='effi/synthetic/complete' 
        queryar(1)='y=f+|y-f|*sign(r-0.5) (r=random number)' 
        queryar(2)='y=f+sqrt(f)*PHI**(-1)(r) (10**-5<r<1)' 
        queryar(3)='complete simulation (dwelltime=>oo)' 
        queryar(4)='complete simulation ' 
        call query(lq,lk,chin,chdf) 
        if(lq.eq.0) then 
         info=1 
         infotext(1)='effi/query' 
         infotext(2)='no substring selected or exited with (q/*)' 
         infotext(3)=' ' 
          goto 1 
        end if 
                                                                         
        querytype='number of Monte Carlo generated spectra' 
        form='i2' 
        chcom='effi/mcarlo/iprobe' 
        value=16 
        if(lq.ge.3) then 
         value=1 
         if(nfit(0).gt.1)then 
          write(nwr,'(a,i2,a)')' only one set(',nfit(1),') is taken' 
          nfit(0)=1 
         end if 
        else 
         value=16 
        end if 
        call askvalue(querytype,form,value,chcom,ncl,nrd,nwr) 
        if(querytype(1:1).eq.'*'.or.querytype(1:1).eq.'q') goto 1 
        iprobe=value 
       else 
        iprobe=1 
       end if 
      end if
      iseed=iseed+123
      mf=0 
      do i=1,mp 
       if (kp(i).eq.1)mf=mf+1  
      end do 
      call mcarlodata(lq,chft,mf,pathw,iprobe,info) 
1     continue
      return

    end subroutine mc_command
